• Home
  • Line#
  • Scopes#
  • Navigate#
  • Raw
  • Download
1#!/bin/bash
2# Copyright 2019 The TensorFlow Authors. All Rights Reserved.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8#     http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15# ==============================================================================
16
17# Utility script that handles downloading, extracting, and patching third-party
18# library dependencies for TensorFlow Lite for Microcontrollers.
19# Called with four arguments:
20# 1 - URL to download from.
21# 2 - MD5 checksum to verify the package's integrity. Use md5sum to create one.
22# 3 - Path to new folder to unpack the library into.
23# 4 - Optional patching action name.
24
25set -e
26
27# Patches the Ambiq Micro SDK to work around build issues.
28patch_am_sdk() {
29  local am_dir="${1}"
30  if [ ! -f ${am_dir}/VERSION.txt ]; then
31    echo "Could not find ${am_dir}, skipping AmbiqMicro SDK patch";
32    return;
33  fi
34
35  local src_dir=${am_dir}/boards/apollo3_evb/examples/hello_world/gcc
36  local dest_dir=${am_dir}/boards/apollo3_evb/examples/hello_world/gcc_patched
37
38  rm -rf ${dest_dir}
39  mkdir ${dest_dir}
40
41  cp "${src_dir}/startup_gcc.c" "${dest_dir}/startup_gcc.c"
42  cp "${src_dir}/hello_world.ld" "${dest_dir}/apollo3evb.ld"
43
44  sed -i -e '114s/1024/1024\*20/g' "${dest_dir}/startup_gcc.c"
45  #sed -i -e 's/main/_main/g' "${dest_dir}/startup_gcc.c"
46
47  sed -i -e '3s/hello_world.ld/apollo3evb.ld/g' "${dest_dir}/apollo3evb.ld"
48  sed -i -e '3s/startup_gnu/startup_gcc/g' "${dest_dir}/apollo3evb.ld"
49  sed -i -e $'22s/\*(.text\*)/\*(.text\*)\\\n\\\n\\\t\/\* These are the C++ global constructors.  Stick them all here and\\\n\\\t \* then walk through the array in main() calling them all.\\\n\\\t \*\/\\\n\\\t_init_array_start = .;\\\n\\\tKEEP (\*(SORT(.init_array\*)))\\\n\\\t_init_array_end = .;\\\n\\\n\\\t\/\* XXX Currently not doing anything for global destructors. \*\/\\\n/g' "${dest_dir}/apollo3evb.ld"
50  sed -i -e $'70s/} > SRAM/} > SRAM\\\n    \/\* Add this to satisfy reference to symbol "end" from libnosys.a(sbrk.o)\\\n     \* to denote the HEAP start.\\\n     \*\/\\\n   end = .;/g' "${dest_dir}/apollo3evb.ld"
51
52  # Add a delay after establishing serial connection
53  sed -ir -E $'s/    with serial\.Serial\(args\.port, args\.baud, timeout=12\) as ser:/    with serial.Serial(args.port, args.baud, timeout=12) as ser:\\\n        # Patched.\\\n        import time\\\n        time.sleep(0.25)\\\n        # End patch./g' "${am_dir}/tools/apollo3_scripts/uart_wired_update.py"
54
55  # Add CPP include guards to "am_hal_iom.h"
56  sed -i -e '57a\
57  #ifdef __cplusplus // Patch\
58  extern "C" {\
59  #endif // End patch
60  ' "${am_dir}/mcu/apollo3/hal/am_hal_iom.h"
61
62  sed -i -e '836a\
63  #ifdef __cplusplus // Patch\
64  }\
65  #endif // End patch
66  ' "${am_dir}/mcu/apollo3/hal/am_hal_iom.h"
67
68  echo "Finished preparing Apollo3 files"
69}
70
71# Fixes issues with KissFFT.
72patch_kissfft() {
73  sed -i -E $'s@#ifdef FIXED_POINT@// Patched automatically by download_dependencies.sh so default is 16 bit.\\\n#ifndef FIXED_POINT\\\n#define FIXED_POINT (16)\\\n#endif\\\n// End patch.\\\n\\\n#ifdef FIXED_POINT@g' tensorflow/lite/micro/tools/make/downloads/kissfft/kiss_fft.h
74  sed -i -E "s@#define KISS_FFT_MALLOC malloc@#define KISS_FFT_MALLOC(X) (void*)(0) /* Patched. */@g" tensorflow/lite/micro/tools/make/downloads/kissfft/kiss_fft.h
75  sed -i -E "s@#define KISS_FFT_FREE free@#define KISS_FFT_FREE(X) /* Patched. */@g" tensorflow/lite/micro/tools/make/downloads/kissfft/kiss_fft.h
76  sed -ir -E "s@(fprintf.*\);)@/* \1 */@g" tensorflow/lite/micro/tools/make/downloads/kissfft/tools/kiss_fftr.c
77  sed -ir -E "s@(exit.*\);)@return; /* \1 */@g" tensorflow/lite/micro/tools/make/downloads/kissfft/tools/kiss_fftr.c
78  echo "Finished patching kissfft"
79}
80
81build_embarc_mli() {
82  gmake -j 4 -C ${1}/lib/make TCF_FILE=${2}
83}
84
85# Main function handling the download, verify, extract, and patch process.
86download_and_extract() {
87  local usage="Usage: download_and_extract URL MD5 DIR [ACTION] [ACTION_PARAM]"
88  local url="${1:?${usage}}"
89  local expected_md5="${2:?${usage}}"
90  local dir="${3:?${usage}}"
91  local action=${4}
92  local action_param1=${5}  # optional action parameter
93  local tempdir=$(mktemp -d)
94  local tempdir2=$(mktemp -d)
95  local tempfile=${tempdir}/temp_file
96  local curl_retries=3
97
98  command -v curl >/dev/null 2>&1 || {
99    echo >&2 "The required 'curl' tool isn't installed. Try 'apt-get install curl'."; exit 1;
100  }
101
102  echo "downloading ${url}" >&2
103  mkdir -p "${dir}"
104  # We've been seeing occasional 56 errors from valid URLs, so set up a retry
105  # loop to attempt to recover from them.
106  for (( i=1; i<=$curl_retries; ++i ))
107  do
108    CURL_RESULT=$(curl -Ls --retry 5 "${url}" > ${tempfile} || true)
109    if [[ $CURL_RESULT -eq 0 ]]
110    then
111      break
112    fi
113    if [[ ( $CURL_RESULT -ne 56 ) || ( $i -eq $curl_retries ) ]]
114    then
115      echo "Error $CURL_RESULT downloading '${url}'"
116      exit 1
117    fi
118    sleep 2
119  done
120
121  # Check that the file was downloaded correctly using a checksum.
122  DOWNLOADED_MD5=$(openssl dgst -md5 ${tempfile} | sed 's/.* //g')
123  if [ ${expected_md5} != ${DOWNLOADED_MD5} ]; then
124    echo "Checksum error for '${url}'. Expected ${expected_md5} but found ${DOWNLOADED_MD5}"
125    exit 1
126  fi
127
128  if [[ "${url}" == *gz ]]; then
129    tar -C "${dir}" --strip-components=1 -xzf ${tempfile}
130  elif [[ "${url}" == *tar.xz ]]; then
131    tar -C "${dir}" --strip-components=1 -xf ${tempfile}
132  elif [[ "${url}" == *bz2 ]]; then
133    curl -Ls "${url}" > ${tempdir}/tarred.bz2
134    tar -C "${dir}" --strip-components=1 -xjf ${tempfile}
135  elif [[ "${url}" == *zip ]]; then
136    unzip ${tempfile} -d ${tempdir2} 2>&1 1>/dev/null
137    # If the zip file contains nested directories, extract the files from the
138    # inner directory.
139    if ls ${tempdir2}/*/* 1> /dev/null 2>&1; then
140      # unzip has no strip components, so unzip to a temp dir, and move the
141      # files we want from the tempdir to destination.
142      cp -R ${tempdir2}/*/* ${dir}/
143    else
144      cp -R ${tempdir2}/* ${dir}/
145    fi
146  else
147    echo "Error unsupported archive type. Failed to extract tool after download."
148  fi
149  rm -rf ${tempdir2} ${tempdir}
150
151  # Delete any potential BUILD files, which would interfere with Bazel builds.
152  find "${dir}" -type f -name '*BUILD' -delete
153
154  if [[ ${action} == "patch_am_sdk" ]]; then
155    patch_am_sdk ${dir}
156  elif [[ ${action} == "patch_kissfft" ]]; then
157    patch_kissfft ${dir}
158  elif [[ ${action} == "build_embarc_mli" ]]; then
159    build_embarc_mli ${dir} ${action_param1}
160  elif [[ ${action} ]]; then
161    echo "Unknown action '${action}'"
162    exit 1
163  fi
164}
165
166download_and_extract "$1" "$2" "$3" "$4" "$5"
167